Program ranasCroando;

  {Creamos a continuacin un mdulo que pregunte,
  de forma estable, sobre el estado inicial de una rana}
  Procedure pedirDatos(i:char; var x:integer);
  var local:char;
  Begin
   Repeat
     write('En el primer turno, la rana ',i,' esta croando (S o N)?');
     readln(local);
    Until ((local='S') or (local='s') or (local='N') or (local='n'));
     If ((local='S') or (local='s')) then x:=1 else x:=0;
   End;

   {Mdulo que guarda el estado actual de cada rana en las variables A,B,C y D}
   Procedure AsignarDatos(var A,B,C,D:integer);
   Begin
    pedirDatos('A',A);{llamamos al mdulo anterior introduciendo el
    caracter 'A' para el parametro de entrada i y almacenando el valor
    de x en la variable global A. Hacemos lo mismo con el resto de ranas}
    pedirDatos('B',B);
    pedirDatos('C',C);
    pedirDatos('D',D);
   End;

    {Mdulo que pregunta, de forma estable,
    en que condiciones van a croar dichas ranas en el siguiente turno}
    Procedure pedirReglas(t:integer; var x:integer);
  var local:char;
  Begin
   Repeat
     write('Si una rana, tiene ',t,' vecina(s) croando, croar en el siguiente turno (S o N)?');
     readln(local);
    Until ((local='S') or (local='s') or (local='N') or (local='n'));
     If ((local='S') or (local='s')) then x:=1 else x:=0;
   End;

   {Mdulo que almacena las condiciones (para todo el programa,
   ya no se modifican) en las variables globales:c0,c1,c2,c3}
   Procedure AsignarCondiciones(var c0,c1,c2,c3:integer);
   Begin
    pedirReglas(0,c0);{Llamamos al mdulo anterior introduciendo el num. 0
    para el parmetro de entrada t, y guardamos la respuesta en la variable
    global c0. Y hacemos lo mismo para almacenar el resto de condiciones}
    pedirReglas(1,c1);
    pedirReglas(2,c2);
    pedirReglas(3,c3);
   End;

   {Funcin que toma el valor 1  0 dependiendo de si una rana tiene que croar
   o no en el siguiente turno dependiendo de sus vecinas: v1,v2 y v3 y
   acorde a las condiciones}
   Function SigTurno(c0,c1,c2,c3,v1,v2,v3:integer):integer;
   Begin
     Case (v1+v2+v3) of
       0: If c0=1 then SigTurno:=1 else Sigturno:=0;
       1: If c1=1 then SigTurno:=1 else SigTurno:=0;
       2: If c2=1 then SigTurno:=1 else SigTurno:=0;
       3: If c3=1 then SigTurno:=1 else SigTurno:=0; end;
    End;

    {Mdulo que actualiza el estado de una rana para el siguiente turno}
    Procedure actualizarVariables(c0,c1,c2,c3:integer; var A,B,C,D:integer);
    var ASigTurno,BSigTurno,CSigTurno,DSigTurno:integer;
    Begin
     ASigTurno:=SigTurno(c0,c1,c2,c3,B,C,D);{Al mdulo anterior le pasamos
     en orden: las condiciones y le asignamos a los parametros v1,v2,v3 sus
     vecinas, es decir, todas las demas(B,C,D). Y a continuacion hacemos lo
     mismo con el resto de ranas} {Asignamos este nuevo valor en otra variable
     para que el valor de A no se modifique antes de usarse para calcular
     el resto de ranas}
     BSigTurno:=SigTurno(c0,c1,c2,c3,A,C,D);
     CSigTurno:=SigTurno(c0,c1,c2,c3,A,B,D);
     DSigTurno:=SigTurno(c0,c1,c2,c3,A,B,C);
     A:=ASigTurno;
     B:=BSigTurno;
     C:=CSigTurno;
     D:=DSigTurno;
    End;

  {Mdulo que dibuja las ranas croando, o no, durante 20 turnos, o hasta que
  se repita un turno}
  Procedure dibujarCharca(A,B,C,D,c0,c1,c2,c3:integer);
   Var contador,Avieja,Bvieja,Cvieja,Dvieja:integer;
    begin
     contador:=0;
      Repeat
     begin
     writeln('Pulse intro para ver el siguiente turno:');
     readln;
     If (A=1) then write('C') else write('_');
     If (B=1) then write('C') else write('_');
     If (C=1) then write('C') else write('_');
     If (D=1) then write('C') else write('_'); writeln;
     Avieja:=A; Bvieja:=B; Cvieja:=C; Dvieja:=D; {Guardamos el estado actual
     de las ranas(el que se acaba de escribir en el monitor), antes de
     actualizar su valor, para compararlo despues con su valor ya actualizado}
     actualizarVariables(c0,c1,c2,c3,A,B,C,D);
     contador:=(contador+1);
      end;
    Until (contador=20) OR ((Avieja=A) AND (Bvieja=B) AND (Cvieja=C) AND (Dvieja=D));
    end;

  VAR
    A,B,C,D,c0,c1,c2,c3:integer;
    global:char;

  BEGIN
    Repeat {Para mayor funcionalidad integramos un bucle
    para reiniciar o suspender el programa}
    begin
     asignarDatos(A,B,C,D);
     AsignarCondiciones(c0,c1,c2,c3);
     dibujarCharca(A,B,C,D,c0,c1,c2,c3);
     writeln('Fin del programa');
     repeat
      writeln('Quiere jugar de nuevo (S o N)?'); readln(global);
     until (global='s') or (global='S') or (global='n') or (global='N')
    end;
    Until (global='n') or (global='N')
  END.


