program ranas;


{Lo primero, colocamos el "uses-CRT" para que Pascal reconozca tanto
funciones,como procedimientos, y hasta el Clear Screen para limpiar
la pantalla al reiniciar.}

uses
crt;

{Hemos creado este procedimiento con el fin de preguntar al
usuario el estado de cada rana, es decir, si croa o no.
Acto seguido, se puede apreciar que llamamos al procedimiento
4 veces (cambiando ste los carcteres y las variables), para las 4 ranas}

    procedure  Estado_inicial_ranas (R: Char; var Rana:char);

       begin
         writeln ('La rana ',R,' est croando? Pulse S o N  ');
         readln (Rana);
         writeln;
         while not ((Rana='S') or (Rana='N')) do
           begin
            writeln ('Por favor, escriba S o N (maysculas)');
            readln (Rana);
            writeln;
           end;
       end;

{Aqu se le llama, lo dicho, 4 veces, cambiando 'R' por el nmero
de la rana, y R1...R4 a Rana}

    procedure Pedir_ranas (var R1,R2,R3,R4:char);
       begin
         Estado_inicial_ranas('1',R1);
         Estado_inicial_ranas('2',R2);
         Estado_inicial_ranas('3',R3);
         Estado_inicial_ranas('4',R4);
       end;

{Esto es lo mismo de antes pero preguntando las condiciones.}


    procedure Pedir_condicion(c:char; var cond:char);
       begin
         writeln('Croarn cuando tengan ',c,' vecinas croando? Pulse S o N');
         readln(cond);
         writeln;
         while not ((cond='S') or (cond='N')) do
           begin
             writeln ('Por favor, escriba S o N (maysculas)');
             readln (cond);
             writeln;
           end;
       end;


    procedure Pedir_condiciones(var cond_0,cond_1,cond_2,cond_3:char);
       begin
         Pedir_condicion('0',cond_0);
         Pedir_condicion('1',cond_1);
         Pedir_condicion('2',cond_2);
         Pedir_condicion('3',cond_3);
       end;

{Esta funcin es la ms importante del programa. Es la base lgica de ste.
Creamos un contador a cero y lo vamos incrementando dependiendo de si las
vecinas croan o no.
El estado siguiente general de la rana (Rst), lo ponemos como N para
ahorrarnos 4 'else' en los 'If' de 'vecinas croando'.
Luego, el valor de contador va a la variable 'vecinas_croando', pero tan slo
es por hacerlo ms intuitivo.
El programa, a groso modo, debe tener en cuenta dos cosas: el estado de las
vecinas y las reglas a aplicar (cond). Con el contador contamos el nmero
de vecinas croando, y luego en los ltimos 'If', comparamos el contador
(vecinas_croando) con las condiciones activas. Si son iguales (ambos contienen
el caracter 'S'),la rana en el siguiente turno croar (luego se llama 4 veces,
una por rana)
Al tratarse de una funcin, el valor que nos da hemos de pedirlo y guardarlo
en determinar_si_rana_croa
}


    function determinar_si_rana_croa (cond_0,cond_1,cond_2,cond_3:char; vecina_1,vecina_2,vecina_3:char):char;
       var
         Rst:char;
         contador,vecinas_croando:integer;
       begin
         Rst:='N';
         contador:=0;
         if vecina_1='S' then contador:=contador+1;
         if vecina_2='S' then contador:=contador+1;
         if vecina_3='S' then contador:=contador+1;

         vecinas_croando:=contador;

         if (vecinas_croando=0) and(cond_0='S') then Rst:='S';
         if (vecinas_croando=1) and(cond_1='S') then Rst:='S';
         if (vecinas_croando=2) and(cond_2='S') then Rst:='S';
         if (vecinas_croando=3) and(cond_3='S') then Rst:='S';


         determinar_si_rana_croa:=Rst;

       end;


{Este simple procedimiento es el que usamos para pintar el estanque.
Luego ser llamado 4 veces, una por rana, para pintar su C (croando)
o su guin bajo (sin croar).
Cabe decir que 'R' es el estado general de la rana, luego
sustituido en el programa general por R1...R4}

    procedure dibujar(R:char);
       begin
         if (R='S') then write('C') else write('_');
       end;

    procedure dibujar_ranas(var R1,R2,R3,R4:char);
       begin
         dibujar(R1);
         dibujar(R2);
         dibujar(R3);
         dibujar(R4);
       end;


{Esta funcin es la que hace que el programa se detenga si se repite
el estado de las ranas en dos turnos consecutivos.
Trabajando con una funcin de salida booleana, y siendo a priori falso,
Si el turno actual y el siguiente (o el actual y el anterior, segn se
mire) son distintos, la funcin se pone en verdadera y sigue dibujando.
Si la funcin no se pusiera verdadera el programa princial lo detectara
y detendra el proceso.)}

    function cambia_estado (R1,R2,R3,R4,R1st,R2st,R3st,R4st:char):boolean;
       begin

         cambia_estado:=false;

         if( R1<>R1st) then cambia_estado:=true;
         if( R2<>R2st) then cambia_estado:=true;
         if( R3<>R3st) then cambia_estado:=true;
         if( R4<>R4st) then cambia_estado:=true;
       end;


{Ahora empieza el programa principal, donde llamaremos a todos los mdulos}


{Las ranas R1...R4 equivalen a las ranas A...D del enunciado.

R1st...R4st son los siguientes turnos de las ranas.

i es el contador que cuenta hasta 20, ya que son 20 turnos mximo.

x es una variable booleana en la que guardamos el valor que nos devuelve
la funcin "cambio_estado"}


var

  R1,R2,R3,R4:char;
  Rst,R1st,R2st,R3st,R4st,cond_0,cond_1,cond_2,cond_3:char;
  i:integer;
  x:boolean;

begin

  ClrScr;

     writeln;
     writeln('                        -----------------------------');
     writeln('                       |    Cmo estn las ranas?   |');
     writeln('                        ----------------------------- ');
     writeln;


  Pedir_ranas(R1,R2,R3,R4);

     writeln;
     writeln('                       -----------------------------');
     writeln('                      |   Cmo croarn las ranas?  |');
     writeln('                       ----------------------------- ');
     writeln;

  pedir_condiciones(cond_0,cond_1,cond_2,cond_3);

  dibujar_ranas(R1,R2,R3,R4);
  writeln;

  i:=1;


{Hemos usado un 'repeat' que repita los mdulos durante 20 turnos, y as
dibuja 19 veces ms, ya que el primer turno lo pintamos directamente con los
datos proporcionados por el usuario.

Una vez pintado el turno actual, calculado con los mdulos de
"determinar_si_rana_croa" las variables de la familia Rst,
que eran las correspondientes al turno siguiente, pasarn a ser las variables
R, que corresponden al turno actual, volviendo a empezar el bucle.
Esto lo hacemos con los 4 "R:=Rst".
}

  repeat

     writeln;

     R1st:=determinar_si_rana_croa (cond_0,cond_1,cond_2,cond_3,R2,R3,R4);
     R2st:=determinar_si_rana_croa (cond_0,cond_1,cond_2,cond_3,R1,R3,R4);
     R3st:=determinar_si_rana_croa (cond_0,cond_1,cond_2,cond_3,R1,R2,R4);
     R4st:=determinar_si_rana_croa (cond_0,cond_1,cond_2,cond_3,R1,R2,R3);

     dibujar_ranas(R1st,R2st,R3st,R4st);
     writeln;


     x:=cambia_estado(R1,R2,R3,R4,R1st,R2st,R3st,R4st);

     R1:=R1st;
     R2:=R2st;
     R3:=R3st;
     R4:=R4st;

     i:=i+1

{El ciclo se repetir hasta que el contador i sume 20, o hasta
que x (cambio_estado) sea falsa}

  until not (x) or (i=20);
  readln;


END.
