Program CuatroRanas;

USES CRT;
TYPE ArrayEstadosRanas = array[0..3] of Boolean;
     ArrayCondiciones  = array[0..3] of Boolean;

{
 [DibujaCuadro]

 entrada: x1,x2,y1,y2:Integer - Las coordenadas de los dos extremos del
          cuadro.
 descripcin: Este procedure se encarga de pintar por pantalla un cuadro.
              Su posicin y tamao viene determinado por los parmetros
              de entrada.
}

Procedure DibujaCuadro(x1,y1,x2,y2:Integer);
VAR Aux:Integer;
BEGIN

   TextColor(White);

   FOR Aux:=x1 TO x2 DO
   BEGIN
      gotoxy(Aux,y1);write('');
      gotoxy(Aux,y2);write('');
   END;

   FOR Aux:=y1 TO y2 DO
   BEGIN
      gotoxy(x1,Aux);write('');
      gotoxy(x2,Aux);write('');
   END;

   gotoxy(x1,y1);write('');
   gotoxy(x2,y1);write('');
   gotoxy(x1,y2);write('');
   gotoxy(x2,y2);write('');
   gotoxy(1,24);

END;

{
 [DibujaCuadroMenu]

 entrada: turno:Integer - El turno en el que se est.
 descripcin: Este procedure se encarga de dibujar el men del juego,
              con el contador de turnos.
}
Procedure DibujaCuadroMenu(turno:Integer);
VAR xAux,yAux:Integer;
BEGIN

   TextColor(White);
   DibujaCuadro(1,20,79,24);
   DibujaCuadro(9,20,64,24);

   gotoxy(9,20); write('');
   gotoxy(9,24); write('');
   gotoxy(64,20);write('');
   gotoxy(64,24);write('');

   gotoxy(3,21); write('TURNO');
   gotoxy(3,22); write(turno,'/20');

   gotoxy(66,21); write('Leyenda :');
   gotoxy(67,22); TextColor(18); write(''); TextColor(White); write('- Cantando');
   gotoxy(67,23); TextColor(2);  write(''); TextColor(White); write('- Silencio');
   gotoxy(1,1);

END;

{
 [Espera]

 descripcin:Mensaje de continuar tras pulsar enter.

}
Procedure Espera;
BEGIN

   TextColor(White);
   gotoxy(25,24);
   write('(Pulse ENTER para continuar)');
   readln;

END;

{
 [MsjInicial]

 descripcin: Mensaje de presentacin/bienvenida del programa.
}
Procedure MsjInicial;
BEGIN

   clrscr;
   DibujaCuadro(18,10,65,14);

   TextColor(White);
   gotoxy(22,12);write('EL JUEGO DE LAS CUATRO RANAS CANTARINAS');
   Espera;

END;



{
 [MsjFinal]

 descripcin: Mensaje de despedida del programa.
}
Procedure MsjFinal;
BEGIN

   clrscr;
   DibujaCuadro(18,10,65,14);

   TextColor(White);
   gotoxy(22,12);write('          ! HASTA LA PRXIMA ');
   Espera;

END;

{
 [DibujaRanaI]

 entrada: x,y:Integer - Coordenadas de desviacin para dibujar la rana.
          estRana - Estado rana que condicionar el color de la rana.
          nomRana - Nombre de la rana: A-B-C-D.
 descripcin: Procedure que con los parmetros x,y dibuja una rana
              que mira hacia la derecha.
}
Procedure DibujaRanaI(x,y:Integer;estRana:Boolean;nomRana:String);
BEGIN

     IF(estRana=true) THEN TextColor(18);
     IF(estRana=false)THEN TextColor(2);

     gotoxy(5+x,1+y);write('                  ,-._');
     gotoxy(5+x,2+y);write('    _          _,",-. `. ');
     gotoxy(5+x,3+y);write('   / `-. ,----"    O    )');
     gotoxy(5+x,4+y);write('  (  `,-" .;         _,"');
     gotoxy(5+x,5+y);write('  _\_(   _  ',nomRana,'       ," ');
     gotoxy(5+x,6+y);write(' / `-.`   )     / /');
     gotoxy(5+x,7+y);write('(  -.   ,"`---"( /__/_ ');
     gotoxy(5+x,8+y);write(' )\\ `-"        `--.(');

END;

{
 [DibujaRanaD]

 entrada: x,y:Integer - Coordenadas de desviacin para dibujar la rana.
          estRana - Estado rana que condicionar el color de la rana.
          nomRana - Nombre de la rana: A-B-C-D.
 descripcin: Procedure que con los parmetros x,y dibuja una rana
              que mira hacia la izquierda.
}
Procedure DibujaRanaD(x,y:Integer;estRana:Boolean;nomRana:String);
BEGIN

     IF(estRana=true)THEN TextColor(18);
     IF(estRana=false)THEN TextColor(2);

     gotoxy(50+x,1+y);write('   _,-.');
     gotoxy(50+x,2+y);write(' ," ,-.`._          _');
     gotoxy(50+x,3+y);write('(    O    `----. ,-" \ ');
     gotoxy(50+x,4+y);write(' `._         ;. `-."  )');
     gotoxy(50+x,5+y);write('    `.     ',nomRana,'    _   )_/_');
     gotoxy(50+x,6+y);write('      \ \     (   ",-" \');
     gotoxy(50+x,7+y);write('   _\__\ )`---"`.   ,-  )');
     gotoxy(50+x,8+y);write('    ),--"        `-" //(');
END;

{
 [DibujaCharca]

  entrada: x,y:Integer - Coordenadas de correccin para dibujar la charca.
  descripcin: Procedure que con los parmetros x,y dibuja la charca.
}
Procedure DibujaCharca(x,y:Integer);
BEGIN

     TextColor(Blue);

     gotoxy(28+x,6+y); write('     ');
     gotoxy(28+x,7+y); write('    ');
     gotoxy(28+x,8+y); write('  ');
     gotoxy(28+x,9+y); write(' ۲');
     gotoxy(28+x,10+y);write('۲');
     gotoxy(28+x,11+y);write(' ۲');
     gotoxy(28+x,12+y);write('  ');
     gotoxy(28+x,13+y);write('   ');
     gotoxy(28+x,14+y);write('     ');

END;

{
 [EstableceValorRana]

 entrada: nomRana:String - El nombre de la rana para el mensaje de pantalla.
 salida: Boolean - El estado de la rana true=cantando y false=silencio.
 descripcin: Function que pide por teclado el estado inicial de las ranas.
}
Function EstableceValorRana(nomRana:String):Boolean;
var estadoCadena:String;
BEGIN

   estadoCadena:='';

   WHILE (estadoCadena <> 'C') AND (estadoCadena <> 'S') DO
   BEGIN
      clrscr;
      DibujaCuadro(12,10,68,14);
      TextColor(White);
      gotoxy(17,12);write(' Introduce el estado de la rana ',nomRana,'("C" - "S") : ');
      readln(estadoCadena);
   END;

   IF(estadoCadena = 'C') THEN  EstableceValorRana:=true;
   IF(estadoCadena = 'S') THEN  EstableceValorRana:=false;

END;

{
 [EstableceCondicion]

 entrada:numVecunasCant:String - El nmero de vecinas para establecer
         condicin.
 salida: Boolean - Devuelve el valor de la condicin. true:canta y false:no canta.
 descripcin: Function que pide por teclado el estado inicial de las ranas.
}
Function EstableceCondicion(numVecinasCant:String):Boolean;
var condicionEstado:String;
BEGIN

   condicionEstado :='';

   WHILE (condicionEstado <> 'N') AND (condicionEstado <> 'S') DO
   BEGIN
     clrscr;
     DibujaCuadro(17,9,62,14);
     TextColor(White);
     gotoxy(20,11);write(' Quiere que las ranas croen cuando');
     gotoxy(20,12);write(' tengan ',numVecinasCant,' vecinas croando. S/N ');
     readln(condicionEstado);
   END;

   IF(condicionEstado = 'N') THEN  EstableceCondicion:=false;
   IF(condicionEstado = 'S') THEN  EstableceCondicion:=true;

END;

{
 [TurnoBase]

  entrada: estadosRanas:arrayEstadosRanas - Dibuja a las ranas dependiendo
           de su estado.
           turno : Dibuja el turno en el que se encuentra.
  descripcin: Establece la pantalla del juego.
}
Procedure TurnoBase(estadosRanas:ArrayEstadosRanas;turno:Integer);
BEGIN

   clrscr;
   DibujaCharca(0,0);

   DibujaRanaI(0,0, estadosRanas[0],'A');
   DibujaRanaI(0,11,estadosRanas[1],'B');
   DibujaRanaD(0,0, estadosRanas[2],'C');
   DibujaRanaD(0,11,estadosRanas[3],'D');
   DibujaCuadroMenu(turno);


END;

{
 [AvisoEstados]

 entrada: estadosRanas:arrayEstadosRanas - Los estados de las ranas
 descripcin: Este procedure muestra el mensaje de los estados de las ranas
              cada turno.
}
Procedure AvisoEstados(estadosRanas:arrayEstadosRanas);
BEGIN

   gotoxy(12,21);

   IF  (estadosRanas[0]=false) AND (estadosRanas[1]=false) AND
       (estadosRanas[2]=false) AND (estadosRanas[3]=false) THEN
   BEGIN
      write('Todas las ranas estan en silencio.');
   END ELSE
   BEGIN
      write('El estado de la rana ');
      IF(estadosRanas[0]=true) THEN write('A, ');
      IF(estadosRanas[1]=true) THEN write('B, ');
      IF(estadosRanas[2]=true) THEN write('C, ');
      IF(estadosRanas[3]=true) THEN write('D ');
      write('es croando.');
   END;
END;

{
 [AvisoCondiciones]

 entrada: condiciones:arrayCondiciones - Las condiciones con las que cantan
          las ranas.
 descripcin: Procedure que se encarga de mostrar un mensaje con las
              condiciones.
}
Procedure AvisoCondiciones(condiciones:arrayCondiciones);
BEGIN

   gotoxy(12,22);
   IF  (condiciones[0]=false) AND (condiciones[1]=false) AND
       (condiciones[2]=false) AND (condiciones[3]=false) THEN
   BEGIN
      write('Las ranas no croaran nunca.');
   END ELSE
   BEGIN
      write('Croarn cuando ');
      IF(condiciones[0]=true) THEN write('0, ');
      IF(condiciones[1]=true) THEN write('1, ');

      IF(condiciones[2]=true) THEN write('2, ');
      IF(condiciones[3]=true) THEN write('3');
      write(' vecinas estn croando.');
   END;

END;

{
  [AvisoCambios]

  entrada: estadosRanasIni,estadosRanasFin:arrayEstadosRanas.
  descripcin: Procedure que se encarga de mostrar un mensaje con lo cambios
               producidos en cada turno.
}
Procedure AvisoCambios(estadosRanasIni,estadosRanasFin:arrayEstadosRanas);
BEGIN

   gotoxy(12,23);
   IF  (estadosRanasIni[0] = estadosRanasFin[0]) AND
       (estadosRanasIni[1] = estadosRanasFin[1]) AND
       (estadosRanasIni[2] = estadosRanasFin[2]) AND
       (estadosRanasIni[3] = estadosRanasFin[3]) THEN
   BEGIN
      write('Todas las ranas mantienen el estado en este turno.');
   END ELSE
   BEGIN
      write('La rana ');
      IF(estadosRanasIni[0] <> estadosRanasFin[0]) THEN write('A, ');
      IF(estadosRanasIni[1] <> estadosRanasFin[1]) THEN write('B, ');
      IF(estadosRanasIni[2] <> estadosRanasFin[2]) THEN write('C, ');
      IF(estadosRanasIni[3] <> estadosRanasFin[3]) THEN write('D, ');
      write('ha cambiado de estado.');
   END;
   gotoxy(1,24);
END;

{
 [TurnoInicio]

 entrada: estadosRanas:arrayEstadosRanas - Los estados ranas.
          condiciones:arrayCondiciones - Las condiciones de cantar.
          turno:Integer - El turno en el que se est.
 descripcin: Establece la pantalla del juego, antes de realizar
              los cambios de estado.
}
Procedure TurnoInicio(estadosRanasIni:arrayEstadosRanas;
                      condiciones:arrayCondiciones;
                      turno:Integer);
BEGIN

     TurnoBase(estadosRanasIni,turno);

     AvisoEstados(estadosRanasIni);

     AvisoCondiciones(condiciones);

     gotoxy(12,23);write('                                                    ');
     gotoxy(1,24);
END;



{
 [TurnoFin]

 entrada: estadosRanas:arrayEstadosRanas - Los estados ranas.
          condiciones:arrayCondiciones - Las condiciones de cantar.
          turno - El turno en el que estamos.
 descripcin: Establece la pantalla del juego, despus de realizar
              los cambios de estado.
}
Procedure TurnoFin(estadosRanasIni,estadosRanasFin:arrayEstadosRanas;
                   condiciones:arrayCondiciones;
                   turno:Integer);
BEGIN

   TurnoInicio(estadosRanasFin,condiciones,turno);

   AvisoCambios(estadosRanasIni,estadosRanasFin);


END;

{
  [CambiaEstadoRana]

  entrada: estadoRana:Boolean - estados de las Ranas.
           numVecinas:Integer - El nmero de vecinas de las ranas.
           condiciones:arrayCondiciones - Las condiciones en las que
           canta una rana.
  salida: Boolean - El nuevo estado de la rana
  descripcin: Function en el que con las condiciones de cambio de cambia
               los estados de las Ranas.
}
Function CambiaEstadoRana(numVecinas:Integer;
                          condiciones:arrayCondiciones):Boolean;
VAR estadoRana:Boolean;
BEGIN

     estadoRana:=false;
     IF (numVecinas=0) AND (condiciones[0]=true) THEN estadoRana:= true;
     IF (numVecinas=1) AND (condiciones[1]=true) THEN estadoRana:= true;
     IF (numVecinas=2) AND (condiciones[2]=true) THEN estadoRana:= true;
     IF (numVecinas=3) AND (condiciones[3]=true) THEN estadoRana:= true;
     CambiaEstadoRana:=estadoRana;

END;

{
 [DameVecinasCantando]

 entrada: rana:integer; estadosRanas:array[1..4] of Boolean
 salida: Integer;
 descripcin: Con el nmero de rana y los estados de las ranas devuelve el
              nmero de vecinas.

}
Function DameVecinasCantando(numRana:Integer;
                             estadosRanas:arrayEstadosRanas):Integer;
Var vecinas:Integer;
BEGIN

     vecinas:=0;

     IF (numRana <> 1) AND (estadosRanas[0]=true) THEN vecinas:=vecinas+1;
     IF (numRana <> 2) AND (estadosRanas[1]=true) THEN vecinas:=vecinas+1;
     IF (numRana <> 3) AND (estadosRanas[2]=true) THEN vecinas:=vecinas+1;
     IF (numRana <> 4) AND (estadosRanas[3]=true) THEN vecinas:=vecinas+1;

     DameVecinasCantando:=vecinas;

END;

{
 [ComprobarEstadosRanas]

 entrada:estadosRanasIni,estadosRanasFin:arrayEstadosRanas - Los estados
         inciales y finales de las ranas en un turno
 salida:Boolean - true si son iguales y false si han cambiado.
 descripcin: Combrueba dos Arrays de estados de Ranas.

}
Function ComprobarEstadosRanas(estadosRanasIni,
                               estadosRanasFin:arrayEstadosRanas):Boolean;
BEGIN

   IF(estadosRanasIni[0]=estadosRanasFin[0]) AND
     (estadosRanasIni[1]=estadosRanasFin[1]) AND
     (estadosRanasIni[2]=estadosRanasFin[2]) AND
     (estadosRanasIni[3]=estadosRanasFin[3]) THEN
   BEGIN
     ComprobarEstadosRanas:=true;
   END ELSE
   BEGIN
     ComprobarEstadosRanas:=false;
   END;


END;

{
 [PintaMensajeFinal]

 entrada: Los turnos manteniendo los estados las ranas.
 descripcin: Muestra un mensaje de victoria o derrota.
}
Procedure PintaMensajeFinal(turnosManteniendoEstado:Integer);
BEGIN
   gotoxy(36,10);
   TextColor(Red);
   IF (turnosManteniendoEstado >= 2 ) THEN
   BEGIN
      write('GANASTE');
   END ELSE
   BEGIN
      write('PERDISTE');
   END;
END;


{
 [LogicaEstadosCambios]

 entrada:estadosRanas:ArrayEstadosRanas - Los estados de las ranas.
         condiciones - Las condiciones en que cantan las ranas.
 descripcin: Comprueba los estados y condiciones para hacer ejecutar la
              lgica de un turno.
}
Procedure LogicaEstadosCambios(estadosRanas:ArrayEstadosRanas;
                               condiciones:ArrayCondiciones);
VAR estadosRanasAux:ArrayEstadosRanas;
    turno,turnosManteniendoEstado,numVecinas:Integer;
BEGIN

   turnosManteniendoEstado:=0;
   FOR turno:=1 TO 20 DO
   BEGIN

      TurnoInicio(estadosRanas,condiciones,turno);
      Espera;

      estadosRanasAux[0]:=CambiaEstadoRana(DameVecinasCantando(1,estadosRanas),condiciones);
      estadosRanasAux[1]:=CambiaEstadoRana(DameVecinasCantando(2,estadosRanas),condiciones);
      estadosRanasAux[2]:=CambiaEstadoRana(DameVecinasCantando(3,estadosRanas),condiciones);
      estadosRanasAux[3]:=CambiaEstadoRana(DameVecinasCantando(4,estadosRanas),condiciones);


      TurnoFin(estadosRanas,estadosRanasAux,condiciones,turno);


      IF (ComprobarEstadosRanas(estadosRanas,estadosRanasAux)) THEN
      BEGIN
         turnosManteniendoEstado:=turnosManteniendoEstado+1;
      END ELSE
      BEGIN
         turnosManteniendoEstado:=0;
      END;

      IF(turnosManteniendoEstado >= 2) THEN turno:=20;

      estadosRanas:=estadosRanasAux;
      Espera;
   END;
   PintaMensajeFinal(turnosManteniendoEstado);
   Espera;
END;

{
 [PreguntarRepetir]

 entrada: String
 salida: Boolean
 descripcin: Function que pide por teclado el estado inicial de las ranas.
}
Function PreguntarRepetir:String;
var repetir:String;
BEGIN

   repetir :='';
   WHILE (repetir <> 'S') AND (repetir <> 'N' ) DO
   BEGIN
      clrscr;
      DibujaCuadro(17,9,68,14);
      TextColor(White);
      gotoxy(20,11);write('Quieres volver a jugar ?S/N : ');
      readln(repetir);
      PreguntarRepetir:=repetir;
   END;
END;

{
 [Partida]

 descripcin: encapsula la lgica de la partida.
}
Procedure Partida;
var condiciones:ArrayCondiciones;
    estadosRanas:ArrayEstadosRanas;
    repetir:String;
BEGIN

     repetir:='';
     WHILE (repetir <>'N') DO
     BEGIN
        (* 1. - Pedir datos *)

        (* 1.1 - Pedir estado inicial ranas *)

        estadosRanas[0]:=EstableceValorRana('A');
        estadosRanas[1]:=EstableceValorRana('B');
        estadosRanas[2]:=EstableceValorRana('C');
        estadosRanas[3]:=EstableceValorRana('D');


        (* 1.2 - Pedir condiciones *)
        condiciones[0]:=EstableceCondicion('0');
        condiciones[1]:=EstableceCondicion('1');
        condiciones[2]:=EstableceCondicion('2');
        condiciones[3]:=EstableceCondicion('3');

        (* 2 - Empezamos la Partida *)
        LogicaEstadosCambios(estadosRanas,condiciones);
        repetir:=PreguntarRepetir;
     END;
END;

(*
 * Empieza el programa
 *)
BEGIN

    MsjInicial;

    Partida;

    MsjFinal;
END.