{-----------------------------------------------------
-- Prctica de diseo 2. Fundamentos de la Informtica
-- Autor: Eduardo Cebollero Campo G09-08
------------------------------------------------------}
Program Ranas2;

        Procedure cogerdatos(rana:char; var croa:integer);
        {Descripcion:
            Este procedimiento se usa para obtener el estado inicial de cada rana.
        Parametros:
            rana: parametro de entrada. Es un identificador y se pasa por valor.
            croa: parmetro de salida. Se usa para almacenar el estado de la rana y se pasa por referencia.
        }
        Begin
        {$I-}
          writeln('Estado de ',rana,' inicial? Croa (1) o No croa (0)');
          readln (croa);
          while (IOResult<>0) or ((croa<>1) and (croa<>0)) do
                  begin
                  writeln('Puedes repetir? Croa (1) o No croa (0)');
                  readln(croa);
                  end;
        {$I+}
        end;

        Procedure cogercondiciones(condicion:integer; var condiciondeseada:integer);
        {Descripcion:
            Este procedimiento se usa para obtener los condicionantes que harn que las ranas croen o dejen de croar.
        Parametros:
            condicion: parametro de entrada. Es un identificador y se pasa por valor.
            condiciondeseada: parmetro de salida. Se usa para almacenar la decisin del usuario y se pasa por referencia.
        }
        Begin
        {$I-}
          writeln('Quieres que croen las ranas cuando tengan ',condicion,' alrededor croando? Si (1) o No (0)');
          readln (condiciondeseada);
          while (IOResult<>0) or ((condiciondeseada<>1) and (condiciondeseada<>0)) do
                  begin
                  writeln('Puedes repetir? Si (1) o No (0)');
                  readln(condiciondeseada);
                  end;
        {$I+}
        if condiciondeseada=1 then condiciondeseada:=condicion else condiciondeseada:=-1;
        {Se pone -1 porque es un valor imposible para la suma posterior}
        end;

        Procedure actualizarvalores (A,B,C,D,condicion0,condicion1,condicion2,condicion3:integer; var A2,B2,C2,D2:integer);
        {Descripcion:
            Este procedimiento se usa para calcular el estado de las ranas en el turno siguiente.
        Parametros:
            A,B,C,D: parametros de entrada. Son utilizados para introducir en la comparacin el estado de cada rana en el turno
                     actual y se pasan por valor.
            condicion0,condicion1,condicion2,condicion3: parmetros de entrada. Se usan para realizar las comparaciones y
                                                         se pasa por valor.
            A2,B2,C2,D2:parametros de salida. Almacenan el estado de cada rana en el turno siguiente y se pasan por referencia.
        }
        Begin
             If ((B+C+D=condicion0) or (B+C+D=condicion1) or (B+C+D=condicion2) or (B+C+D=condicion3)) then A2:=1 else A2:=0;
             If ((A+C+D=condicion0) or (A+C+D=condicion1) or (A+C+D=condicion2) or (A+C+D=condicion3)) then B2:=1 else B2:=0;
             If ((B+A+D=condicion0) or (B+A+D=condicion1) or (B+A+D=condicion2) or (B+A+D=condicion3)) then C2:=1 else C2:=0;
             If ((B+C+A=condicion0) or (B+C+A=condicion1) or (B+C+A=condicion2) or (B+C+A=condicion3)) then D2:=1 else D2:=0;
        end;

        Procedure pintaranas (A2,B2,C2,D2:integer;turno:word);
        {Descripcion:
            Este procedimiento se usa para representar en pantalla el estado de cada rana en el turno actual.
        Parametros:
            A2,B2,C2,D2: parametros de entrada.Introducen el estado de cada rana y se pasan por valor.
            turno: parmetro de entrada. Introduce el valor del turno en el que nos encontramos y se pasa por valor.
        }
        Begin
            if turno<10 then write(' ');

             write(turno, ': ');
             If A2=1 then write('C') else write('_');
             If B2=1 then write('C') else write('_');
             If C2=1 then write('C') else write('_');
             If D2=1 then writeln('C') else writeln('_');
        end;
Var
   A,B,C,D,A2,B2,C2,D2:integer;
   condicion0,condicion1,condicion2,condicion3:integer;
   contturnos:word;
   soniguales:boolean;
   continuar:char;
Begin
     continuar:= 'Y';
while ((continuar='Y') or (continuar='y')) do
Begin
   writeln;
   writeln ('Vamos a hacer croar ranas!');
   cogerdatos('A',A);
   cogerdatos('B',B);
   cogerdatos('C',C);
   cogerdatos('D',D);
   cogercondiciones(0,condicion0);
   cogercondiciones(1,condicion1);
   cogercondiciones(2,condicion2);
   cogercondiciones(3,condicion3);

     writeln('    ABCD');
     contturnos:=1;
     soniguales:=false;

     pintaranas (A,B,C,D,0);

     while (contturnos<=20) and (soniguales=false) do
           begin
                actualizarvalores(A,B,C,D,condicion0,condicion1,condicion2,condicion3,A2,B2,C2,D2);
                soniguales:=((A=A2) and (B=B2) and (C=C2) and (D=D2));
                pintaranas (A2,B2,C2,D2,contturnos);
                contturnos:=contturnos+1;
                A:=A2;B:=B2;C:=C2;D:=D2;
           end;
     writeln ('Quieres volver a jugar? Si (Y) o No (N)');
     readln (continuar);
             while NOT ((continuar='Y') or (continuar='N') or (continuar='y') or (continuar='n')) do
                  begin
                  writeln('Quieres volver a jugar? Si (Y) o No (N)');
                  readln (continuar);
                  end;
end;
end.
