Program RanasCroando;

{Aqu se definen los tipos de variables que vamos a usar en el programa.}

Type
  EstadoRanas=array [1..4] of boolean;
  NumeroRanasVecinasCroando=array [0..3] of boolean;



Procedure EstadoInicialRanas (var X:EstadoRanas);

{Vamos a guardar los datos de inicio que indican como van a estar las ranas
en el momento de comenzar el juego.}
{El valor del estado de las ranas (X) es una variable porque devolveremos el
resultado para su uso fuera tambin de este procedimiento.}

Var
  i:integer;    {Para los bucles.}
  Valor:char;   {Para almacenar el valor introducido por pantalla.}
  Rana:char;    {Para almacenar el nmero de rana que se est analizando.}

Begin
  For i:=1 to 4 do      {Valor de inicio de cada una de las ranas.}
    Begin
      Case i of
        1:Rana:='A';    {Para mostrar en pantalla}
        2:Rana:='B';    {la rana que estamos usando}
        3:Rana:='C';    {en este momento.}
        4:Rana:='D'
      End;

      Write('Indique estado inicial Rana ',Rana,' (c-croa, n-no croa): ');
      Readln(Valor);

      While ((Valor<>'c') and (Valor<>'n')) do  {Bucle por si el valor}
        Begin                                   {introducido no es correcto.}
          Writeln('El valor introducido no es correcto. Por favor,');
          Write('indique si quiere que la Rana ',Rana,' croe (c)  no croe (n): ');
          Readln(Valor);
        End;

      If Valor='c' then     {Aqu se vara el valor inicial de cada una de}
        X[i]:=true          {las ranas.}
      else
        X[i]:=false;
    End;
End;



Procedure CondicionesJuego (var Cantidad:NumeroRanasVecinasCroando);

{Aqu se van a almacenar las reglas de cada uno de los juegos, la cantidad
de ranas que se quiere que halla alrededor croando para que croe cada una
de las ranas.}
{El nmero de ranas croando (Cantidad) es variable porque devolveremos el valor que nos
halla dado cada uno de los 4 posibles resultados.}

Var
  i:integer;    {Para los bucles.}
  Valor:char;   {Para almacenar el valor introducido por pantalla.}

Begin
  For i:=0 to 3 do      {Aqu se preguntan todas las combinaciones posibles que podemos tener}
    Begin               {para que la rana croe en el siguiente turno (sin contarse ella misma).}
      Write('Quiere que la rana croe cuando halla ',i,' ranas croando? (s  n): ');
      Readln(Valor);

      While ((Valor<>'s') and (Valor<>'n')) do  {Bucle por si el valor}
        Begin                                   {introducido no es correcto.}
          Writeln('El valor introducido no es correcto. Por favor,');
          Writeln('indique si quiere que la rana croe (s)  no croe (n)');
          Write('cuando halla ',i,' ranas croando: ');
          Readln(Valor);
        End;

        If Valor='s' then       {Aqu se almacena con cuntas ranas alrededor}
          Cantidad[i]:=true     {tiene que croar en el siguiente turno cada}
        else                    {una de las ranas.}
          Cantidad[i]:=false;
    End;
End;



Procedure MostrarEstadoRanas (Turno:integer; Y:EstadoRanas);

{Aqu se muestra por pantalla si las ranas estn croando (C) o no (_)
y el turno de juego (turno) en el que se est en ese momento.}
{Todas las variables son de entrada y no tengo ni de salida ni de
entrada-salida porque las voy a usar slo para visualizacin y no voy a
operar sobre las mismas. El estado actual de las ranas se almacena en Y.}

Var
  i:integer;    {Para los bucles.}

Begin
  Write(Turno,': ');      {Se muestra el nmero de turno por pantalla.}

  For i:=1 to 4 do
    If Y[i] then        {Se muestra el valor de cada una de las ranas por}
      Write('C')        {pantalla en el turno dado (C-croa, _-no croa).}
    else
      Write('_');

  Writeln;
End;



Function NuevoEstadoRana (Z:EstadoRanas; j,C:integer;
                         Suma:NumeroRanasVecinasCroando):boolean;

{Aqu se calcula el estado actual de cada una de las ranas dependiendo de lo
que hacen las ranas vecinas (U) y de las reglas que nos han dado previamente
al comienzo del juego. El estado anterior de las ranas lo almacenamos en Z.}
{Usamos una funcin porque devolvemos un nico valor y del tipo que queremos
usar posteriormente sin tener que definirlo fuera.}

Var
  x:integer;    {Para operaciones internas de la funcin.}

Begin
  If Z[j] then        {Si la rana que se est calculando est croando, se}
    x:=C-1            {se resta su valor al total de ranas croando, y si no}
  else                {es as se deja el total como est.}
    x:=C;

  If Suma[x] then             {Si el nmero de ranas croando alrededor}
    NuevoEstadoRana:=true     {coincide con el valor dado al principio para}
  else                        {que la rana croe, la rana croar.}
    NuevoEstadoRana:=false;   {Si no es as, la rana no croar.}
End;



Procedure CalculoNuevoEstado (var V,W:EstadoRanas;
                             Suma:NumeroRanasVecinasCroando);

{Aqu se va a calcular el valor que deben tener las ranas en el turno que se
va a mostrar por pantalla (se obvia el primer turno que no hay que hacer
nada porque viene definido por el usuario).}
{Primero se copia el vector del estado actual al vector de estado anterior (V),
para posteriormente poder compararlos y comprobar si siguen siendo iguales.
Luego se modifica el valor del vector estado actual con el nuevo resultado
del turno. Esto se hace sumando cuntas ranas hay en total croando.
Luego se compara rana a rana con los valores dados para que sigan croando 
no (restando previamente del total si la rana analizada croa o no).}
{Ponemos los dos estados de las ranas como variables, ya que tenemos que
devolver su valor al programa principal y usarlo modificado tambin en otras
funciones y procedimientos. El nmero de ranas vecinas croando es slo de
consulta, con lo que es slo de entrada.}

Var
  i:integer;    {Para los bucles.}
  TotalRanasCroando:integer;      {Para almacenar cuntas ranas hay
                                  en total croando cada turno.}

Begin
  For i:=1 to 4 do      {Copia del vector del estado actual de las ranas al}
    V[i]:=W[i];         {vector del estado anterior.}

  TotalRanasCroando:=0;     {Inicializo la variable}

  For i:=1 to 4 do      {Se calcula cuntas ranas hay en total croando en el}
    If W[i] then        {turno actual.}
      TotalRanasCroando:=TotalRanasCroando+1;

  For i:=1 to 4 do
    Begin
      If NuevoEstadoRana (V,i,TotalRanasCroando,Suma) then
        W[i]:=true       {Aqu se asigna el nuevo estado de las ranas}
      else               {dependiendo del resultado obtenido en la funcin}
        W[i]:=false;     {de clculo.}
    End;
End;



Function ComparaTurnos (A,B:EstadoRanas):boolean;

{Aqu se van a comparar los estados actual con el anterior para ver si son
iguales.}

Begin
ComparaTurnos:=((A[1]=B[1]) and (A[2]=B[2]) and (A[3]=B[3]) and (A[4]=B[4]));
End;



{Aqu comienza el programa principal en el que se integrarn todas las
funciones y procedimientos definidos anteriormente.}

Var
  EstadoAnteriorRanas:EstadoRanas;      {Aqu se almacena el ltimo estado de las ranas mostrado en pantalla (turno anterior).}
  EstadoActualRanas:EstadoRanas;        {Aqu se almacena el estado que se va a mostrar en pantalla (turno actual).}
  NumeroTurno:integer;                  {Aqu se guarda el nmero de turno en el que est el juego.}
  RanasAlrededor:NumeroRanasVecinasCroando;   {Aqu se guarda si se quiere que
                 se croe dependiendo del nmero de ranas que hay alrededor.}
  VolverJugar:char;     {Para almacenar si se quiere seguir jugando  no al
                        terminar cada partida.}
  TurnosIguales:boolean;   {Para introducir el valor de la comparacin de si
                           el turno actual y el anterior son distintos  si
                           son iguales.}

Begin
  VolverJugar:='s';     {Inicializo la variable.}

  While (VolverJugar='s') do
    Begin
      If (VolverJugar<>'s') then        {Bucle por si el valor}
        Begin                           {introducido no es correcto.}
          Writeln('No me ha dicho si quiere volver a jugar.');
          Write('Quiere volver a jugar? (s  n) ');
          Readln(VolverJugar);
        End
      else
        Begin
          NumeroTurno:=1;       {Inicializamos el Nmero del turno al
                                comienzo del juego.}

          EstadoInicialRanas (EstadoActualRanas);   {Llamo al procedimiento
                             que pregunta cul va a ser el estado inicial
                             del juego, cmo van a estar las ranas.}

          CondicionesJuego (RanasAlrededor);     {Llamo al procedimiento que
                           pregunta cules van a ser las reglas del juego, en
                           qu condiciones tiene que croar cada rana.}

          MostrarEstadoRanas (NumeroTurno,EstadoActualRanas);   {Llamo al procedimiento
                             que muestra por pantalla el estado de las ranas
                             el primer turno del juego.}

          TurnosIguales:=false;  {Inicializamos variable para la comparacin.}

          Repeat
            Writeln('Pulse ENTER para ver el siguiente estado.');
            Readln;              {Hasta que no se indique en pantalla no
                                 pasamos al siguiente turno.}

            NumeroTurno:=NumeroTurno+1;         {Valor del turno actual.}


            CalculoNuevoEstado (EstadoAnteriorRanas,EstadoActualRanas,
                               RanasAlrededor);   {Llamo al procedimiento que
                               va a calcular el nuevo valor de las ranas.}

            MostrarEstadoRanas (NumeroTurno,EstadoActualRanas);   {Llamo al procedimiento
                             que muestra por pantalla el estado de las ranas
                             el turno actual del juego.}

            TurnosIguales:=ComparaTurnos(EstadoAnteriorRanas,EstadoActualRanas);
                         {Aqu se compara si hay dos turnos seguidos iguales.}

          Until ((NumeroTurno=20) or TurnosIguales);  {Si se llega a 20 turnos
                o si el estado de las ranas es el mismo en dos turnos
                consecutivos finalizamos el juego actal.}

          Writeln('Juego finalizado.');  {Fin del juego. Se muestra por
                        pantalla si el juego ha llegado al final del mismo 
                        si los resultados de dos turnos consecutivos son
                        iguales, con lo que los posteriores tampoco variarn.}

          If NumeroTurno=20 then
            Writeln('Se han completado los 20 turnos del juego.')
          else
            Writeln('Las ranas no varan de un turno a otro.');

          Write('Quiere volver a jugar? (s  n) ');  {Para volver a jugar }
          Readln(VolverJugar)                         {terminar y salir.}
        End;
    End;
End.