PROGRAM ranas;


CONST

    TECLA_SI = 'S';
    TECLA_NO = 'N';

    CROA = 'C';
    NO_CROA = '_';

    TURNOS = 20;


VAR

    repetir : char; {Almacenan las opciones introducidas por el usuario}
    debeCroar : char;

    hayEquilibrio : boolean; {Almacena si el estado de las ranas es igual al
                              turno anterior}

    i : integer; {Contador para el bucle FOR}

    estaCroandoA : boolean; {Lo que hacen las ranas este turno}
    estaCroandoB : boolean;
    estaCroandoC : boolean;
    estaCroandoD : boolean;

    vaAcroarA : boolean; {Lo que van a hacer las ranas el proximo turno}
    vaAcroarB : boolean;
    vaAcroarC : boolean;
    vaAcroarD : boolean;

    croarSi0 : boolean; {Lo que van a hacer las ranas en funcion de sus vecinas}
    croarSi1 : boolean;
    croarSi2 : boolean;
    croarSi3 : boolean;

    vecinasDeAcroando : integer; {El numero de vecinas croando de cada rana}
    vecinasDeBcroando : integer;
    vecinasDeCcroando : integer;
    vecinasDeDcroando : integer;


{------------------------------------------------------------------------------}


{Esta funcion calcula el numero de vecinas croando que tiene una rana, por lo
tanto devuelve un valor de tipo entero. Los parametros se pasan por valor ya que
es una funcion y no los modifica}
FUNCTION vecinasCroando(estaCroandoLarana, estaCroandoA, estaCroandoB,
                        estaCroandoC, estaCroandoD : boolean) : integer;


VAR

    resultado : integer;


BEGIN

    resultado := 0; {Inicializamos a cero}

    IF (estaCroandoA) THEN
        inc(resultado);
    IF (estaCroandoB) THEN
        inc(resultado);
    IF (estaCroandoC) THEN
        inc(resultado);
    IF (estaCroandoD) THEN
        inc(resultado); {Sumamos uno por cada rana que croa}

    IF (estaCroandoLaRana) THEN
        dec(resultado); {Si la propia rana croa, restamos uno, ya que la
                             hemos contado antes (por eso pasamos dos veces la
                             misma rana como parametro, para poder generalizar
                             para cualquier caso}

    vecinasCroando := resultado;

END;


{------------------------------------------------------------------------------}


{Este procedimiento hace una pregunta al usuario y almacena su respuesta
(comprobando que sea valida). La variable que almacena la respuesta se pasa por
referencia, ya que queremos modificarla y compartirla con  otros subprogramas}
PROCEDURE preguntarSiOno(VAR respuesta : char);


BEGIN

    REPEAT
        write ('? (', TECLA_SI, '/', TECLA_NO, '): ');
        {$I-}
        readln (respuesta);
        {SI+}
        respuesta := upcase (respuesta); {Asi admite minusculas y mayusulas}
        IF ((ioresult <> 0) OR ((respuesta <> TECLA_SI) AND (respuesta <> TECLA_NO))) THEN
            writeln ('Opcion incorrecta, intente de nuevo');
    UNTIL ((respuesta = TECLA_SI) OR (respuesta = TECLA_NO));

END;


{------------------------------------------------------------------------------}


{Esta funcion devuelve TRUE si la rana va a croar el proximo turno y FALSE en
caso contrario, en funcion del numero de ranas vecinas croando que tiene. Todos
sus parametros son pasados por valor, ya que las funciones no modifican los
parametros. Devuelve un valor booleano, por lo que se ha comentado}
FUNCTION vaAcroar(vecinasCroando : integer; croarSi0, croarSi1, croarSi2,
                  croarSi3 : boolean) : boolean;


BEGIN

    CASE (vecinasCroando) OF

        0 : vaAcroar := croarSi0;
        1 : vaAcroar := croarSi1;
        2 : vaAcroar := croarSi2;
        3 : vaAcroar := croarSi3;

    END;

END;


{------------------------------------------------------------------------------}


{Este procedimiento imprime el caracter que simboliza el croar o el silencio de
una rana, en funcion de si croa o no, evidentemente. El parametro se le pasa por
valor, ya que no se modifica, y este subprograma es un procedimiento porque no
calcula un valor (si solo hiciera eso seria una funcion)}
PROCEDURE imprimirSiEstaCroando (estaCroando : boolean);


BEGIN

    IF (estaCroando) THEN
        write(CROA)
    ELSE
        write(NO_CROA);

END;


{------------------------------------------------------------------------------}


{Programa principal}
BEGIN

    REPEAT

        {Preguntamos cuales son las ranas que croan y cuales las que no}
        write('Empieza croando la rana A');
        preguntarSiOno(debeCroar);
        vaAcroarA := (debeCroar = TECLA_SI);
        write('Empieza croando la rana B');
        preguntarSiOno(debeCroar);
        vaAcroarB := (debeCroar = TECLA_SI);
        write('Empieza croando la rana C');
        preguntarSiOno(debeCroar);
        vaAcroarC := (debeCroar = TECLA_SI);
        write('Empieza croando la rana D');
        preguntarSiOno(debeCroar);
        vaAcroarD := (debeCroar = TECLA_SI);

        {Preguntamos que haran las ranas en funcion de sus vecinas, en cada caso}
        write('Deben croar las ranas que tengan 0 vecinas croando');
        preguntarSiOno(debeCroar);
        croarSi0 := (debeCroar = TECLA_SI);
        write('Deben croar las ranas que tengan 1 vecinas croando');
        preguntarSiOno(debeCroar);
        croarSi1 := (debeCroar = TECLA_SI);
        write('Deben croar las ranas que tengan 2 vecinas croando');
        preguntarSiOno(debeCroar);
        croarSi2 := (debeCroar = TECLA_SI);
        write('Deben croar las ranas que tengan 3 vecinas croando');
        preguntarSiOno(debeCroar);
        croarSi3 := (debeCroar = TECLA_SI);

        {Pasamos a los "turnos"}
        i := 1;
        REPEAT

            {En el turno actual, se actualiza el estado de las ranas (el futuro
            pasa a ser el presente)}
            estaCroandoA := vaAcroarA;
            estaCroandoB := vaAcroarB;
            estaCroandoC := vaAcroarC;
            estaCroandoD := vaAcroarD;

            {Se imprime si las ranas croan o no}
            imprimirSiEstaCroando(estaCroandoA);
            imprimirSiEstaCroando(estaCroandoB);
            imprimirSiEstaCroando(estaCroandoC);
            imprimirSiEstaCroando(estaCroandoD);

            {Calculamos las vecinas que croan de cada rana}
            vecinasDeAcroando := vecinasCroando(estaCroandoA, estaCroandoA, estaCroandoB, estaCroandoC, estaCroandoD);
            vecinasDeBcroando := vecinasCroando(estaCroandoB, estaCroandoA, estaCroandoB, estaCroandoC, estaCroandoD);
            vecinasDeCcroando := vecinasCroando(estaCroandoC, estaCroandoA, estaCroandoB, estaCroandoC, estaCroandoD);
            vecinasDeDcroando := vecinasCroando(estaCroandoD, estaCroandoA, estaCroandoB, estaCroandoC, estaCroandoD);

            {Se calcula el proximo estado de cada rana, lo que hara el proximo
            turno}
            vaAcroarA := vaAcroar(vecinasDeAcroando, croarSi0, croarSi1, croarSi2, croarSi3);
            vaAcroarB := vaAcroar(vecinasDeBcroando, croarSi0, croarSi1, croarSi2, croarSi3);
            vaAcroarC := vaAcroar(vecinasDeCcroando, croarSi0, croarSi1, croarSi2, croarSi3);
            vaAcroarD := vaAcroar(vecinasDeDcroando, croarSi0, croarSi1, croarSi2, croarSi3);

            {Calculamos si las ranas van a repetir el estado actual. Si es asi,
            ese estado se repetira siempre, habra equilibrio}
            hayEquilibrio := ((estaCroandoA = vaAcroarA) AND
                              (estaCroandoB = vaAcroarB) AND
                              (estaCroandoC = vaAcroarC) AND
                              (estaCroandoD = vaAcroarD));

            writeln;
            inc(i);

        UNTIL ((hayEquilibrio) OR (i > TURNOS));
        {Si hay equilibrio o ya se han hecho todos los turnos, termina}

        IF (hayEquilibrio) THEN
            writeln('Las ranas seguiran en el ultimo estado indefinidamente');
            {Ademas, si hay equilibrio lo indicamos}

        write('Quiere volver a jugar');
        preguntarSiOno(repetir);

    UNTIL (repetir = TECLA_NO);
    {Y preguntamos si se quiere volver a jugar hasta que se diga que no}

END. {Fin del programa}
